﻿// ==UserScript==
// @include http://*.vk.com/*
// @include http://vk.com/*
// ==/UserScript==

var UPDATE_INTERVAL = 1000;
var bgLink;

/**
 * Vkontakte user type.
 * @constructor
 */
function VkUser(id, holder) {
  this.id = id;
  // Источник - стена, диалоги, др.
  var hObj = {};
  hObj[holder] = null;
  this.holder = hObj;
  // TRUE or FALSE
  this.Result = undefined;
  // Код иконки для внедрения
  this.Code = undefined;
}
VkUser.prototype.getFirstHolderType = function() {
  for (h in this.holder) {
    if (h) return h;
  }
  return false;
};
VkUser.prototype.hasHolderType = function(h_type) {
  for (h in this.holder) {
    if (h_type === h) return true;
  }
  return false;
};
VkUser.prototype.addHolderType = function(h_type) {
  this.holder[h_type] = 'settedFromProcessing';
};

var ParentHolders = {
  photo_popup_comment: 'fl_l pv_thumb',   // Поп-ап комментариев к фото.
  wall_comment: 'reply_table',            // Комментарии на стене.
  video_popup_comment: 'mv_thumb',        // Поп-ап комментариев к видео.
  // group_popup: 'member_row clear_fix',    // Поп-ап приглашения в группу.
  group_popup: 'group_p_row',             // Приглашения в группу.
  im_page: 'dialogs_photo',               // Страница диалогов /im.
  mail_page: 'mail_photo',                // Страница сообщений /mail.
  id_page: 'profile_photo_link'           // Страница пользователя /[a-z0-9_.].
};

function getNewUsers() {
  var new_users = [];
  for (ph in ParentHolders) {
    if (!ph) continue;
    var pNList = document.getElementsByClassName(ParentHolders[ph]);
    if (!pNList || !pNList.length) continue;
    
    for (var i=0; i<pNList.length; i++) {
      if (childExist(pNList.item(i), 'BlClientIcon')) continue;
      var sub = pNList.item(i).firstElementChild;
      // Для элемента, упакованного в div. См. стр. /mail
      var ahref = (ParentHolders[ph] === 'mail_photo')?sub.firstChild.href:sub.href;
      var id = getUserId(ahref);
      if (isUserIdValid(id))
        new_users.push(new VkUser(id, ph));
    }
  }
  var currId = getCurrentUserPageId();
  //console.log('currId=' + currId);
  if (currId) new_users.push(new VkUser(currId, 'id_page'));
  return new_users;
}

function setNewIcons(ready) {
  for (ph in ParentHolders) {
    if (!ph) continue;
    
    if (ph === 'id_page' && document.getElementById('profile_photo_link')) {
      var profile = document.getElementById('profile_photo_link').parentNode;
      if (childExist(profile, 'BlClientIcon')) continue;
      var id = getCurrentUserPageId();
      if (id && ready.hasOwnProperty(id) && ready[id].holder[ph])
      profile.innerHTML += ready[id].holder[ph];
    }
    
    var pNList = document.getElementsByClassName(ParentHolders[ph]);
    if (!pNList || !pNList.length) continue;
    
    for (var i=0; i<pNList.length; i++) {
      // console.log('pNList');
      if (childExist(pNList.item(i), 'BlClientIcon')) continue;
      var sub = pNList.item(i).firstElementChild;
      // Для элемента, упакованного в div. См. стр. /mail
      var ahref = (ParentHolders[ph] === 'mail_photo')?sub.firstChild.href:sub.href;
      var id = getUserId(ahref);
      if (isUserIdValid(id)) {
        if (ready.hasOwnProperty(id) && ready[id].holder[ph])
            pNList.item(i).innerHTML += ready[id].holder[ph];
      }
    }
  }
}

function getCurrentUserPageId() {
  var avatar = document.getElementById('profile_photo_link');
  var rawid = (avatar)?avatar.getElementsByTagName('img').item(0).src:false;
  if (rawid) return 'id'+/[0-9]+(?=\/)/.exec(rawid);
  return false;
}

function getProcessedLinks() {
  bgLink.postMessage({id: "need_processed"});
}

function isUserIdValid(user_id) {
  var patt = new RegExp('[^a-z0-9_.]', 'ig');
  return !patt.test(user_id);
}

function getUserId(user_url) {
  var parts = user_url.split('/');
  return parts[parts.length-1];
}

function childExist(parent, child_class) {
  if (parent && parent.childNodes) {
    var chNodes = parent.childNodes;
    for (var i=0; i<chNodes.length; i++) {
      if (chNodes[i] && chNodes[i].className == child_class)
        return true;
    }
  }
  return false;
}

function sendLinks(new_users) {
  if (!new_users || !new_users.length) return;
	bgLink.postMessage({id: "linksFromPage", links: new_users});
}

function manageLinks() {
  try {
    sendLinks(getNewUsers());
    // Получение уже обработанных ссылок.
    getProcessedLinks();
  } catch(e) {}
}

opera.extension.onmessage = function(event) {
  var req = JSON.parse(event.data);
  switch(req.id) {
    case 'hello':
      bgLink = event.source;
    break;
    case 'processed':
      if (req.toWork) {
        setNewIcons(req.processedLinks);
      }
    break;
  }
};

setInterval(manageLinks, UPDATE_INTERVAL);