﻿var REQUESTS_INTERVAL = 100;

var extensionButton;

var finished = new ProcessedUsers();
var inwork = new UnProcessedUsers();
var customer = new Customer();

function ProcessedUsers() {
  this.users = {};
}
ProcessedUsers.prototype.add = function(new_user) {
  this.users[new_user.id] = new_user;
};
ProcessedUsers.prototype.hasUserWithId = function(id_get) {
  return this.users.hasOwnProperty(id_get);
};
ProcessedUsers.prototype.getUserById = function(id_get) {
  if (this.hasUserWithId(id_get)) {
    return this.users[id_get]; }
  else {
    return false;
  }
};

function UnProcessedUsers() {
  this.users = [];
}
UnProcessedUsers.prototype.add = function(new_user) {
  this.users.push(new_user);
};

UnProcessedUsers.prototype.pop = function() {
  return this.users.pop();
};

UnProcessedUsers.prototype.getUserById = function(id_get) {
  for (var i=0; i<this.users.length; i++) {
    if (this.users[i].id === id_get)
      return this.users[i];
  }
  return false;
};
UnProcessedUsers.prototype.count = function() {
  return this.users.length;
};

function Customer() {
  this.login;
  this.passwd;
  /**
   * API ключ для доступа пользователя к api.blclient.ru.
   */
  this.apiuid;
  this.NameUser;
  this.newsCommon;
  this.news;
}
Customer.prototype.signIn = function(customerObj) {
  // Эти параметры первоначально сохраняются в Поп-апе.
  // alert(customerObj.apiuid);
  if (localStorage.login && localStorage.passwd && 
      localStorage.toWork === 'true') {
    this.login = localStorage.login;
    this.passwd = localStorage.passwd;
    this.getApiUid(function(msg) {
      if (msg.hasOwnProperty('error')) {
        //alert(msg.error);
        localStorage.toWork = false;
        opera.extension.broadcastMessage({id: "signedOn", api_uid: false, 
          error: msg.error});
      } else {
        customerObj.apiuid = msg.ApiUid;
        extensionButton.icon = "icons/18x18_yes.png";
        opera.extension.broadcastMessage({id: "signedOn", 
          api_uid: customerObj.apiuid});
      }
    });
  }
};

/**
 * Получает API ключ с сервиса для указанного логина и пароля.
 */
Customer.prototype.getApiUid = function(callback) {
  var requestUrl = 'http://api.blclient.ru/getAPIKey/?' +
                    'email=' + encodeURIComponent(this.login) +
                    '&password=' + encodeURIComponent(this.passwd);
  var xhr = new XMLHttpRequest();
  xhr.open('GET', requestUrl, true)
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4) {
      var resp = xhr.responseText;
      if (resp) {
        var respO = JSON.parse(resp);
        if (respO.responce === 'good') {
          callback({ApiUid: respO.ApiUid});
        } else {
          callback({error:'Сервис возвратил Error на запрос API ключа для' + 
            'вашей учетной записи. Проверьте логин и пароль!'});
        }
        
      }
    }
  }
  xhr.send();
};

Customer.prototype.getNews = function(customerObj) {
  var requestUrl = 'http://api.blclient.ru/news/?api=' + 
      encodeURIComponent((this.apiuid)?this.apiuid:'$api');
  var xhr = new XMLHttpRequest();
  xhr.open('GET', requestUrl, true);
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4) {
      var resp = xhr.responseText;
      if (resp) {
        var respO = JSON.parse(resp);
        if (respO.responce) {
          // customer.NameUser = respO.NameUser;
          opera.extension.broadcastMessage({id: "news", 
            api_uid: customerObj.apiuid, newsObj: respO});
        }
      }
    }
  }
  xhr.send();
};

function enqueueNewUser(new_users) {
  for (var i=0; i<new_users.length; i++) {
    var new_user = new_users[i];
    // Тут нужно добавлять методы типа пользователя,т.к. они потерялись при
    // пересылке из content скрипта.
    
    new_user.getFirstHolderType = function() {
      for (h in this.holder) {
        if (h) return h;
      }
      return false;
    };
    new_user.hasHolderType = function(h_type) {
      for (h in this.holder) {
        if (h_type === h) return true;
      }
      return false;
    };
    new_user.addHolderType = function(h_type) {
      this.holder[h_type] = null;
    };
    
    // Обработанная очередь и очередь на обр. не содержит элементов с таким id.
    if ((!inwork.count() || !inwork.getUserById(new_user.id)) &&
        !finished.hasUserWithId(new_user.id))
    {
      // Постановка id в очередь на обработку.
      inwork.add(new_user);
      continue;
    }
    
    // Возможно этот пользователь уже в обработанных и нужно добавить холдер.
    var new_h = new_user.getFirstHolderType();
    if (new_h) {
      if (finished.hasUserWithId(new_user.id)) {
        // Если код для текущего холдера уже установлен - пропускаем.
        if (finished.getUserById(new_user.id).hasHolderType(new_h)) {
          continue;
        }
      }
      // Добавление нового пользователя в очередь на обработку.
      // В очереди на обработку может быть много пользователей с одним id,
      // но разными холдерами.
      if (!inwork.getUserById(new_user.id) || 
          !inwork.getUserById(new_user.id).hasHolderType(new_h))
        inwork.add(new_user);
    }
  }
}

function processQueue() {
  if (localStorage.toWork === 'false' || !inwork.count() || !customer.apiuid)
    return;
  var user = inwork.pop();
  var h = user.getFirstHolderType();
  if (finished.hasUserWithId(user.id)) {
    finished.getUserById(user.id).addHolderType(h);
  } else {
    finished.add(user);
  }
  
  var requestUrl = 'http://api.blclient.ru/getBLClient/?' + 
      'toolbar=on' +
      '&ApiKey=' + encodeURIComponent(customer.apiuid) +
      '&vk=' + encodeURIComponent(user.id) +
      '&ParentHolders=' + encodeURIComponent(h);
  var xhr = new XMLHttpRequest();
  xhr.open('GET', requestUrl, true);
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4) {
      var resp = xhr.responseText;
      if (resp) {
        var respO = JSON.parse(resp);
        finished.getUserById(user.id).Result = respO['Result'];
        finished.getUserById(user.id).holder[h] = respO['Code'];
      }
    }
  }
  xhr.send();
}

function setupConnection() {
  opera.extension.onconnect = function(event) {
    event.source.postMessage(JSON.stringify({id: 'hello'}));
  }
}

window.addEventListener('load', function() {
  var ToolbarUIItemProperties = {
    disabled: false,
    title: "BLClient.ru - черный список покупателей",
    icon: "icons/18x18_no.png",
    popup: {
      href: 'popup.html',
      width: 388,
      height: 147
    }
  }
  extensionButton = opera.contexts.toolbar.createItem(ToolbarUIItemProperties);
  opera.contexts.toolbar.addItem(extensionButton);
  setupConnection();
}, false);

opera.extension.onmessage = function(event) {
  switch(event.data.id) {
    case "linksFromPage":
      enqueueNewUser(event.data.links);
      break;
    case "need_processed":
      event.source.postMessage(JSON.stringify({id: "processed", 
        "processedLinks": finished.users, "toWork": localStorage.toWork}));
      break;
    case "isToWork":
      opera.extension.broadcastMessage({id: "isToWork", 
          "toWork": localStorage.toWork, "api_uid": customer.apiuid});
      break;
    case "signIn":
      customer.login = event.data.login;
      customer.passwd = event.data.passwd;
      localStorage.toWork = true;
      customer.signIn(customer);
      break;
    case "need_news":
      customer.getNews(customer);
      break;
    case "stop":
      localStorage.toWork = false;
      customer.apiuid = undefined;
      extensionButton.icon = 'icons/18x18_no.png';
      break;
  }
};

customer.signIn(customer);
setInterval(processQueue, REQUESTS_INTERVAL);