﻿function captureLogin(inputEl) {
  if (inputEl.value) {
    switch (inputEl.id) {
      case 'login':
        localStorage.login = (inputEl.value != 'login')?inputEl.value:false;
        break;
      case 'passwd':
        localStorage.passwd = (inputEl.value != 'passwd')?inputEl.value:false;
        break;
    }
  }
}

function createExitBlock() {
  if (!document.getElementById('exitBlock')) {
    var exitBlock = document.createElement('div');
    exitBlock.id = 'exitBlock';
    var newHeight = document.body.clientHeight - 
      document.getElementById('news').clientHeight;
    if (exitBlock.style.height < newHeight)
      exitBlock.style.height = newHeight;
    document.getElementById('holder').appendChild(exitBlock);
    //
    var exitButton = document.createElement('button');
    exitButton.innerHTML = 'Выход';
    exitButton.addEventListener('click', function() {
      opera.extension.postMessage({id: 'stop'});
      window.close();
    }, false);
    document.getElementById('exitBlock').appendChild(exitButton);
  }      
}

function createHolder() {
  if (!document.getElementById('holder')) {
    var holder = document.createElement('div');
    holder.id = 'holder';
    document.body.appendChild(holder);
  }
}

function createNews() {
  if (!document.getElementById('news')) {
    var news = document.createElement('div');
    news.id = 'news';
    document.getElementById('holder').appendChild(news);
  }
}

function createLoginBlock() {
  var loginBlock = document.createElement('div');
  loginBlock.id = 'loginBlock';
  var loginTitleText = document.createElement('span');
  loginTitleText.id = 'loginTitleText';
  loginTitleText.innerText = 'Авторизуйтесь: ';
  var login = document.createElement('input');
  login.type = 'text';
  login.id = 'login';
  login.onfocus = function() {if(this.value === 'login') this.value='';};
  login.onkeyup = function() {captureLogin(this);};
  var passwd = document.createElement('input');
  passwd.type = 'password';
  passwd.id = 'passwd';
  passwd.onfocus = function() {if(this.value === 'passwd') this.value='';};
  passwd.onkeyup = function() {captureLogin(this);};
  var ok = document.createElement('button');
  ok.innerText = 'ok';
  ok.onclick = function() {getApiUid();};
  
  loginBlock.appendChild(loginTitleText);
  loginBlock.appendChild(login);
  loginBlock.appendChild(passwd);
  loginBlock.appendChild(ok);
  document.getElementById('holder').appendChild(loginBlock);
  document.getElementById('login').value = 
    (localStorage.login)?localStorage.login:'login';
  document.getElementById('passwd').value = 
    (localStorage.passwd)?localStorage.passwd:'passwd';
}

function createPanel(resp) {
  createHolder();
  // Если в текущий момент обработка не работает, показать панель логина
  if (!resp.toWork || resp.toWork == 'false' || !resp.api_uid) {
    createLoginBlock();
  } else if (resp.api_uid) {
    createNews();
    createExitBlock();
  }
  // Независимо от работает или не работает запрашивать новости.
  opera.extension.postMessage({id: "need_news"});
}

function getApiUid() {
  var login = document.getElementById('login').value;
  var passwd = document.getElementById('passwd').value;
  // Проверка, что логин и пароль не пустые и запрос ключа.
  if (login && passwd) {
    opera.extension.postMessage({id: "signIn", login: login, passwd: passwd});
  } else {
    alert('Поля логина и пароля не могут быть пустыми!');
  }
}

// News block autoscroll.
var totalScroll = 0;
function scrollToDiv() {
  if (document.getElementById('news')) {
    var newsHeight = document.getElementById('news').scrollHeight;
    //console.log(newsHeight);
    if (newsHeight-totalScroll <= 0) totalScroll = 0;
    $('div,html').animate({
        scrollTop: totalScroll
    }, 500, 'linear');
    totalScroll += 20;
  }
}


opera.extension.onmessage = function(event) {
  switch(event.data.id) {
    case 'isToWork':
      createPanel(event.data);
    break;
    case 'news':
      createNews();
      document.getElementById('news').innerHTML = event.data.newsObj.news;
      if (event.data.api_uid) {
        if (document.getElementById('loginBlock'))
          document.getElementById('holder').removeChild(
            document.getElementById('loginBlock'));       
        createExitBlock();
      }
    break;
    case "signedOn":
      if (event.data.hasOwnProperty('error')) {
        createNews();
        document.getElementById('news').innerText = event.data.error;
      }
      else if (event.data.api_uid) {
        opera.extension.postMessage({id: "need_news"});
      }
    break;
  }
}

setInterval(scrollToDiv, 1500);

window.addEventListener('DOMContentLoaded', function() {
  opera.extension.postMessage({id: "isToWork"});
}, false);